<script lang="ts">
  import Card from "./lib/Card.svelte";

  // export let state: GameState;
  // export let settings: GameSettings;
</script>

<section class="panel">
  <p>
    There are <strong>6</strong> different suits. Each suit has
    <strong>9</strong> ranks, numbered 1 through 9, for a total of
    <strong>54</strong> cards.
  </p>

  <h3>Goal</h3>
  <p>
    Be the first player to plant 3 adjacent flags, or 5 total flags along the
    border. Only the player with the strongest army (i.e. card combination) at
    each border location may plant their flag there.
  </p>

  <h3>On your turn</h3>
  <p>If possible, you must perform each of the following actions in order:</p>
  <ol>
    <li>
      <h4>Place a card</h4>
      <p>
        Add your card from your hand to one of the 9 locations on your side of
        the border.
      </p>
      <p>
        Up to 3 cards may be placed at each location. Cards may not be placed at
        a location where a flag has been planted.
      </p>
    </li>
    <li>
      <h4>Draw a card</h4>
      <p>Take a card from the deck and add it to your hand.</p>
    </li>
  </ol>

  <h3>Planting a flag</h3>
  <p>
    At any point during your turn, you may attempt to plant your flag at any
    location where you have placed 3 cards.
  </p>
  <p>
    You will successfully plant the flag if your 3 cards are a stronger
    combination than the opponent's in that location. If the opponent has not
    yet placed 3 cards you can still plant the flag <em>if</em>, based on all
    the cards placed along the border, it's impossible for them to beat your
    combination.
  </p>
  <p>
    <em>If you fail the attempt you may not plant any more flags that turn.</em>
  </p>

  <h3>Combinations</h3>
  These are the five different kinds of card combinations, listed from strongest
  to weakest.
  <dl>
    <dt>
      Straight Flush
      <span class="combo-example">
        <Card inline card={14} />
        <Card inline card={15} />
        <Card inline card={16} />
      </span>
    </dt>
    <dd>Three cards with connected ranks of the same suit</dd>

    <dt>
      Three of a Kind
      <span class="combo-example">
        <Card inline card={2} />
        <Card inline card={11} />
        <Card inline card={20} />
      </span>
    </dt>
    <dd>Three cards of the same rank</dd>

    <dt>
      Flush
      <span class="combo-example">
        <Card inline card={28} />
        <Card inline card={31} />
        <Card inline card={35} />
      </span>
    </dt>
    <dd>Three cards of the same suit</dd>

    <dt>
      Straight
      <span class="combo-example">
        <Card inline card={32} />
        <Card inline card={42} />
        <Card inline card={52} />
      </span>
    </dt>
    <dd>Three cards with connected ranks of any suit</dd>

    <dt>
      High Cards
      <span class="combo-example">
        <Card inline card={21} />
        <Card inline card={33} />
        <Card inline card={45} />
      </span>
    </dt>
    <dd>Any three cards</dd>
  </dl>

  <p>
    Between two combinations of the same kind, the combination with the highest
    total ranks is the strongest. If there is still a tie, the player who first
    placed their 3rd card at the location wins.
  </p>

  <h3>End of the game</h3>
  <p>The game ends immediately when either:</p>
  <ul>
    <li>A player plants 3 adjacent flags.</li>
    <div class="text-center italic">~ or ~</div>
    <li>A player plants 5 flags anywhere along the border.</li>
  </ul>
  <p>The player who planted these flags wins the game!</p>
</section>

<style>
  section {
    background-color: linen;
    font-size: 85%;
    height: 100%;
    overflow-y: auto;
  }

  h3,
  h4 {
    font-weight: 500;
  }

  p {
    margin-top: 0em;
    margin-bottom: 0.75em;
  }
  ol {
    padding-left: 1.5em;
  }

  dt {
    font-weight: 500;
    display: flex;
    justify-content: space-between;
  }
  .combo-example {
    text-align: right;
  }
  dd {
    margin-left: 0;
    margin-bottom: 1em;
  }

  ul {
    list-style: disc;
  }
  ul > li {
    margin-left: 1.5em;
  }
</style>
